import peasy.*;

PeasyCam cam;

PVector p1 = new PVector(0,0,0);
PVector p2 = new PVector(100,0,0); 
PVector p3 = new PVector(100,100,0); 

PMatrix3D  xform = new PMatrix3D();
boolean    matrixMode = false;

float    angle = 25;
PVector  trans = new PVector(50,0,0);

void setup()
{
  // set the window size + 3d mode
  size(800, 600, P3D);

  // setup the camera
  cam = new PeasyCam(this, 1500);
  cam.setMinimumDistance(5);
  cam.setMaximumDistance(5000);
  perspective(radians(25), (float)width / (float)height, .1, 5000);
  
  xform.reset();
  xform.rotate(radians(angle),0,0,1);
  xform.translate(trans.x,trans.y,trans.z);
  
}

void draw()
{
  background(0);

  coordSys(100);

  // draw triangle

  pushMatrix();
  
  if(matrixMode)
  {
    applyMatrix(xform);
    
    fill(255, 0, 150);
    beginShape(TRIANGLES);
    vertex(p1.x, p1.y, p1.z);
    vertex(p2.x, p2.y, p2.z);
    vertex(p3.x, p3.y, p3.z);
    endShape();
  }
  else
  {
    rotate(radians(angle));
    translate(trans.x,trans.y,trans.z);
    
    fill(255, 255, 150);
    beginShape(TRIANGLES);
    vertex(p1.x, p1.y, p1.z);
    vertex(p2.x, p2.y, p2.z);
    vertex(p3.x, p3.y, p3.z);
    endShape();
  }
  
  popMatrix();

}

// draws a simple coordinate system
void coordSys(float size)
{
  pushStyle();

  stroke(255, 0, 0);
  line(0, 0, 0, 
  size, 0, 0);

  stroke(0, 255, 0);
  line(0, 0, 0, 
  0, size, 0);

  stroke(0, 0, 255);
  line(0, 0, 0, 
  0, 0, size);

  popStyle();
}
